import kraken.Constants
import os
import os.path
from types import *
import time


def helperLocalFilePrefix():
    if os.name == "nt":
       return '<a href="file:///'
    else:
       return '<a href="file:'

def paragraphField(entry, propertyName, label = None, cssClass=None, sequenceNewLine = 0):
    if cssClass == None:
        classPart = ""
    else:
        classPart = " class="+cssClass
    value = entry.getExtendedProperty(propertyName)
    if label == None:
        labelPart = ""
    else:
        labelPart = label + " = "
    valuePart = ""
    typeOfField = type(value)
    if typeOfField == ListType:
         valuePart = ""
         for a in value:
             valuePart += str(a)
             if sequenceNewLine:
                 valuePart += "<br/>\n"
             else:
                 valuePart += ", "
         if not sequenceNewLine:
             valuePart = valuePart[:-2] 
    elif (typeOfField == time.struct_time) or (typeOfField == TupleType and len(value)==9):  
         valuePart = time.strftime("%a, %d %b %Y %H:%M", value)
    else:
         valuePart = str(value)    
    return "<p class=" + classPart + ">" + labelPart + valuePart + "</p>\n"
    
        
def paragraphNativeMetaData(entry, metadata):
      temp = ""
      metadataDir = (entry.parentDirName + "/" + entry.getProperty("directoryName") + "/" + 
          kraken.Constants.DIRNAME_METADATA + "/")
      for descriptor in metadata.descriptors.values():
          if not descriptor.existsInEntry(entry):
              continue
          temp += (helperLocalFilePrefix() + descriptor.getNativeFileName(entry) + '">' 
                + "[" + descriptor.getProperty("name") + "]" + "</a>\n")
      return temp

def linkNativeMetaData(metadataDir, mdFile, mdLabel):
       if os.path.exists(metadataDir + mdFile):
          return helperLocalFilePrefix() + metadataDir + "/" + mdFile + '">' +  mdLabel + "</a>\n"
       else:
           return ""            
    
def linkEntryHtml(entry):
  """
     Creates the link to the generated entry html file
  """
  link = (entry.parentDirName + "/" + entry.getProperty("directoryName") + 
            "/" + kraken.Constants.DIRNAME_METADATA +
            "/" + kraken.Constants.FILENAME_ENTRY_HTML
         )
  temp = (helperLocalFilePrefix() + link + '" title="' + link + '">' + 
                     "[html]" + "</a><br/>\n"
          )
  return temp
    
    
def linkLocalFiles(entry, metadata):
   temp = ""    
   # there are local files
   if len(entry.getProperty("localFileNames")) != 0:
      for x in entry.getProperty("localFileNames"):
        link = entry.parentDirName + "/" + entry.getProperty("directoryName") + "/" + x 
        temp += (helperLocalFilePrefix() + link + '" title="' + link + '">' +
                     entry.getProperty("title") + "</a><br/>\n"
                )
      return temp          
   # there are no local files, but we have remote ones   
   if len(entry.getProperty("originalURIs")) != 0:
      for x in entry.getProperty("originalURIs"):          
         temp += ('<a href="' + x + 
            '" title="' + x +
            '">' +  entry.getProperty("title") + "</a><br/>\n")
      return temp
   # it might be a note!
   notemetadata = metadata.descriptors["Note"]      
   if notemetadata.existsInEntry(entry):
      link = notemetadata.getNativeFileName(entry)
      temp += (helperLocalFilePrefix() + link +
         '" title="' + link +
         '">' +  entry.getProperty("title") + "</a><br/>\n")
      return temp   
   # ok, just put a link to the dir, and let the guy figure it out. 
   temp += (helperLocalFilePrefix() + entry.parentDirName + "/" + 
                    entry.getProperty("directoryName") + "/" + '">' + entry.getProperty("title")
                     + "</a>\n"
                    )
   return temp
    
def entryTypeIcon(entry):
    temp = ""
    for a in entry.getProperty("entryTypes"):
        temp += '<img src="' + a + '.gif" alt="' + a + '"/>'
    return temp
